#ifndef RTCPCL_LRFtoPCL_H__
#define RTCPCL_LRFtoPCL_H__

#include <rtcpcl/config.h>

#include <rtm/idl/BasicDataTypeSkel.h>
#include <rtm/idl/ExtendedDataTypesSkel.h>
#include <rtm/idl/InterfaceDataTypesSkel.h>
#include <rtm/Manager.h>
#include <rtm/DataFlowComponentBase.h>
#include <rtm/CorbaPort.h>
#include <rtm/DataInPort.h>
#include <rtm/OutPort.h>
#include <pcl/point_cloud.h>
#include <pcl/point_types.h>
#include <pointcloud.hh>
#include <string>


namespace RTCPCL
{

    class RTCPCL_LRFtoPCL
    : public RTC::DataFlowComponentBase
    {
        public:
            RTCPCL_LRFtoPCL(RTC::Manager* manager);
            ~RTCPCL_LRFtoPCL();

            virtual RTC::ReturnCode_t onInitialize();
            virtual RTC::ReturnCode_t onActivated(RTC::UniqueId ec_id);
            virtual RTC::ReturnCode_t onDeactivated(RTC::UniqueId ec_id);
            virtual RTC::ReturnCode_t onExecute(RTC::UniqueId ec_id);

        private:
            PointCloudTypes::PointCloud corba_out_;
            RTC::OutPort<PointCloudTypes::PointCloud> corba_out_port_;
            PointCloudTypes::PointCloud PCL1_Out_;
            RTC::OutPort<PointCloudTypes::PointCloud> PCL1_Out_port_;

 	    RTC::RangeData m_LRF0_RangeIn_;
            RTC::InPort<RTC::RangeData> m_LRF0_RangeIn_port_;

 	    RTC::TimedPose3D LRF0_Pose_;
            RTC::InPort<RTC::TimedPose3D> LRF0_Pose_port_;

 	    RTC::RangeData m_LRF1_RangeIn_;
            RTC::InPort<RTC::RangeData> m_LRF1_RangeIn_port_;
 	    RTC::TimedPose3D LRF1_Pose_;
            RTC::InPort<RTC::TimedPose3D> LRF1_Pose_port_;
            unsigned int seq_;

            pcl::PointCloud<pcl::PointXYZRGB>::Ptr cloud_;
    };

}; // namespace RTCPCL


extern "C"
{
    DLL_EXPORT void rtc_init(RTC::Manager* manager);
};

#endif // RTCPCL_LRFtoPCL_H__

